\name{ringWidths}
\alias{ringWidths}
\title{Ring widths }
\description{This function can compute the ring widths (mm) from the ring
borders detected on an image section.}
\usage{ringWidths(image, last.yr = NULL, ...)}
\arguments{
  \item{image}{character or matrix. Either path of an image section
or an array representing a gray matrix.}
  \item{last.yr}{year of formation of the newest ring. If
NULL then the rings are numbered from one
(right) to the number of detected rings
(left).}
  \item{\dots}{arguments to be passed to \code{\link{ringBorders}}.}
}

\value{data frame with the ring widths.}

\author{Wilson Lara, Carlos Sierra, Felipe Bravo}




\examples{
## (not run) Read one image section:
image1 <- system.file("P105_a.tif", package="measuRing")       
## (not run) columns in gray matrix to be included/excluded:
Toinc <- c(196,202,387,1564) 
Toexc <- c(21,130,197,207,1444,1484)
## (not run) tree-ring widths
rwidths <- ringWidths(image1,inclu = Toinc,exclu = Toexc,last.yr=NULL)
str(rwidths)
##plot of computed tree-ring widths:
maint <- 'Hello ring widths!'
plot(rwidths,type='l',col = 'red',main = maint,
     xlab = 'Year',ylab = 'Width (mm)')    
}
